{
    "$graph": [
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "id": "#gpx_qdump.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ]
        },
        {
            "label": "hmmsearch_create_jobs",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.hmm_path)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "hmmsearch_create_jobs",
            "arguments": [
                "-no-merge-hmms"
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-hmm-path"
                    },
                    "id": "#hmmsearch_create_jobs.cwl/hmm_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#hmmsearch_create_jobs.cwl/output"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-seqids"
                    },
                    "id": "#hmmsearch_create_jobs.cwl/seqids"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "workpath",
                    "inputBinding": {
                        "prefix": "-workpath"
                    },
                    "id": "#hmmsearch_create_jobs.cwl/workpath"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#hmmsearch_create_jobs.cwl/jobs"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.workpath)"
                    },
                    "id": "#hmmsearch_create_jobs.cwl/workdir"
                }
            ],
            "id": "#hmmsearch_create_jobs.cwl"
        },
        {
            "label": "hmmsearch_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMax": 3000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.hmm_path)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.workdir)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.asn_cache)",
                            "writable": false
                        },
                        {
                            "entryname": "fam.mft",
                            "entry": "${ var blob = '# fam.mft created for hmmsearch_wnode from input hmms_tab File\\n'; if ( inputs.hmms_tab == null ) { return blob; }  else { return blob + inputs.hmms_tab.path; } }"
                        }
                    ]
                }
            ],
            "baseCommand": "hmmsearch_wnode",
            "arguments": [
                "-backlog",
                "1",
                "-cut_ga",
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#hmmsearch_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "fam.mft",
                    "inputBinding": {
                        "prefix": "-fam"
                    },
                    "id": "#hmmsearch_wnode.cwl/fam"
                },
                {
                    "type": "Directory",
                    "id": "#hmmsearch_wnode.cwl/hmm_path"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#hmmsearch_wnode.cwl/hmms_tab"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "/panfs/pan1.be-md.ncbi.nlm.nih.gov/gpipe/bacterial_pipeline/system/bin",
                    "inputBinding": {
                        "prefix": "-hmmsearch-path"
                    },
                    "id": "#hmmsearch_wnode.cwl/hmmsearch_path"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#hmmsearch_wnode.cwl/input_jobs"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#hmmsearch_wnode.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#hmmsearch_wnode.cwl/output_dir"
                },
                {
                    "type": "File",
                    "id": "#hmmsearch_wnode.cwl/proteins"
                },
                {
                    "type": "Directory",
                    "id": "#hmmsearch_wnode.cwl/workdir"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#hmmsearch_wnode.cwl/output"
                }
            ],
            "id": "#hmmsearch_wnode.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "file concatenation",
            "baseCommand": "cat",
            "stdout": "cat.out",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cat_array_of_files.cwl/files_in"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat_array_of_files.cwl/file_out",
                    "outputBinding": {
                        "glob": "cat.out"
                    }
                }
            ],
            "id": "#cat_array_of_files.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "cwl split wrapper",
            "baseCommand": "split",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "id": "#split.cwl/chunk_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#split.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs",
                    "inputBinding": {
                        "position": 5,
                        "valueFrom": "$(inputs.mask)"
                    },
                    "id": "#split.cwl/mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-n l//",
                        "separate": false
                    },
                    "id": "#split.cwl/nchunks"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": ".xml",
                    "inputBinding": {
                        "position": 3,
                        "separate": false,
                        "prefix": "--additional-suffix="
                    },
                    "id": "#split.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.mask)?*$(inputs.suffix)"
                    },
                    "id": "#split.cwl/jobs"
                }
            ],
            "id": "#split.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/asn_cache"
                },
                {
                    "type": "Directory",
                    "id": "#main/hmm_path"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/hmms_tab"
                },
                {
                    "type": "File",
                    "id": "#main/lds2"
                },
                {
                    "type": "File",
                    "id": "#main/proteins"
                },
                {
                    "type": "string",
                    "id": "#main/scatter_gather_nchunks"
                },
                {
                    "type": "File",
                    "id": "#main/seqids"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/collect_hmm_results/file_out",
                    "id": "#main/hmm_hits"
                },
                {
                    "type": "File",
                    "outputSource": "#main/hmmsearch_create_jobs/jobs",
                    "id": "#main/jobs"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/hmmsearch_create_jobs/workdir",
                    "id": "#main/workdir"
                }
            ],
            "steps": [
                {
                    "run": "#cat_array_of_files.cwl",
                    "in": [
                        {
                            "source": "#main/hmmsearch_wnode_qdump/output",
                            "id": "#main/collect_hmm_results/files_in"
                        }
                    ],
                    "out": [
                        "#main/collect_hmm_results/file_out"
                    ],
                    "id": "#main/collect_hmm_results"
                },
                {
                    "run": "#hmmsearch_create_jobs.cwl",
                    "in": [
                        {
                            "source": "#main/hmm_path",
                            "id": "#main/hmmsearch_create_jobs/hmm_path"
                        },
                        {
                            "source": "#main/seqids",
                            "id": "#main/hmmsearch_create_jobs/seqids"
                        }
                    ],
                    "out": [
                        "#main/hmmsearch_create_jobs/jobs",
                        "#main/hmmsearch_create_jobs/workdir"
                    ],
                    "id": "#main/hmmsearch_create_jobs"
                },
                {
                    "run": "#tt_hmmsearch_wnode_plus_qdump.cwl",
                    "scatter": "#main/hmmsearch_wnode_qdump/input_jobs",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/hmmsearch_wnode_qdump/asn_cache"
                        },
                        {
                            "source": "#main/hmm_path",
                            "id": "#main/hmmsearch_wnode_qdump/hmm_path"
                        },
                        {
                            "source": "#main/hmms_tab",
                            "id": "#main/hmmsearch_wnode_qdump/hmms_tab"
                        },
                        {
                            "source": "#main/split_jobs/jobs",
                            "id": "#main/hmmsearch_wnode_qdump/input_jobs"
                        },
                        {
                            "source": "#main/lds2",
                            "id": "#main/hmmsearch_wnode_qdump/lds2"
                        },
                        {
                            "source": "#main/proteins",
                            "id": "#main/hmmsearch_wnode_qdump/proteins"
                        },
                        {
                            "source": "#main/hmmsearch_create_jobs/workdir",
                            "id": "#main/hmmsearch_wnode_qdump/workdir"
                        }
                    ],
                    "out": [
                        "#main/hmmsearch_wnode_qdump/output"
                    ],
                    "id": "#main/hmmsearch_wnode_qdump"
                },
                {
                    "run": "#split.cwl",
                    "in": [
                        {
                            "source": "#main/hmmsearch_create_jobs/jobs",
                            "id": "#main/split_jobs/input"
                        },
                        {
                            "source": "#main/scatter_gather_nchunks",
                            "id": "#main/split_jobs/nchunks"
                        }
                    ],
                    "out": [
                        "#main/split_jobs/jobs"
                    ],
                    "id": "#main/split_jobs"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "label": "hmmsearch_wnode and gpx_qdump combined workflow to apply scatter/gather",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/asn_cache"
                },
                {
                    "type": "Directory",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmm_path"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmms_tab"
                },
                {
                    "type": "File",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/input_jobs"
                },
                {
                    "type": "File",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/lds2"
                },
                {
                    "type": "File",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/proteins"
                },
                {
                    "type": "Directory",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/workdir"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_hmmsearch_wnode_plus_qdump.cwl/gpx_qdump/output",
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/output"
                }
            ],
            "steps": [
                {
                    "run": "#gpx_qdump.cwl",
                    "in": [
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/output",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/gpx_qdump/input_path"
                        },
                        {
                            "default": "hmm_hits.asn",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/gpx_qdump/output_name"
                        },
                        {
                            "default": "*",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#tt_hmmsearch_wnode_plus_qdump.cwl/gpx_qdump/output"
                    ],
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/gpx_qdump"
                },
                {
                    "run": "#hmmsearch_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/asn_cache",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmm_path",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/hmm_path"
                        },
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmms_tab",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/hmms_tab"
                        },
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/input_jobs",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/input_jobs"
                        },
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/lds2",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/lds2"
                        },
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/proteins",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/proteins"
                        },
                        {
                            "source": "#tt_hmmsearch_wnode_plus_qdump.cwl/workdir",
                            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/workdir"
                        }
                    ],
                    "out": [
                        "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode/output"
                    ],
                    "id": "#tt_hmmsearch_wnode_plus_qdump.cwl/hmmsearch_wnode"
                }
            ],
            "id": "#tt_hmmsearch_wnode_plus_qdump.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
